commit 1276b391b4b068655b1d4511d51421302c1a7849
Author: Xi Ruoyao <xry111@xry111.site>
Date:   Fri Aug 22 15:00:53 2025

    LoongArch: Fix ICE in highway-1.3.0 testsuite [PR121634]
    
    I can't believe I made such a stupid pasto and the regression test
    didn't detect anything wrong.
    
            PR target/121634
    
    gcc/
    
            * config/loongarch/simd.md (simd_maddw_evod_<mode>_<su>): Use
            WVEC_HALF instead of WVEC for the mode of the sign_extend for
            the rhs of multiplication.
    
    gcc/testsuite/
    
            * gcc.target/loongarch/pr121634.c: New test.
    
    (cherry picked from commit 64932714a0786c6ba164cff3468f633cc67b23f5)

diff --git a/gcc/testsuite/gcc.target/loongarch/pr121634.c b/gcc/testsuite/gcc.target/loongarch/pr121634.c
new file mode 100644
index 00000000000..325173ad798
--- /dev/null
+++ b/gcc/testsuite/gcc.target/loongarch/pr121634.c
@@ -0,0 +1,15 @@
+/* PR target/121634: ICE in highway-1.3.0 testsuite */
+/* { dg-do compile } */
+/* { dg-options "-O2 -march=la464 -mabi=lp64d" } */
+
+typedef short v8i16 __attribute__ ((vector_size (16)));
+typedef int v4i32 __attribute__ ((vector_size (16)));
+typedef long __m128i __attribute__ ((__vector_size__ (16)));
+__m128i x, y;
+
+__m128i
+WidenMulPairwiseAdd (__m128i a, __m128i b)
+{
+  y = (__m128i)__builtin_lsx_vmaddwod_w_h ((v4i32)x, (v8i16){}, (v8i16){});
+  return y;
+}

